# Instructions

0. You need a class that acts as the notifier. The only requirement is that the
   class implements a `bool Notify()` method. Write this class in a header. In
   my example the method just prints a notification every time it is called.

1. Create a dictionary for the `TNotifyLink<MyNotifier>` instantiation.
   See https://root.cern/manual/io_custom_classes for detailed instructions, the
   following is just one way to do it.
   ```
   $: rootcling -f DictMyNotifier.cxx mynotifier.hxx LinkDef.h
   ```
   This generates the file `DictMyNotifier.cxx`

2. Compile the program including the dictionary in the compilation:
   ```
   $: g++ -O3 -o repro.out DictMyNotifier.cxx repro.cpp `root-config --cflags --glibs`
   ```

3. Run the program, notice that at each new file in the chain there will be a
   new notification printed.
