#include <TChain.h>
#include <TTree.h>
#include <TFile.h>
#include <TNotifyLink.h>
#include <iostream>
#include "mynotifier.hxx"

void generateData()
{
   TFile f{"testfile.root", "RECREATE", "file for testing"};

   int var1;

   TTree tree{"Events", "Events"};
   tree.Branch("column1", &var1, "column1/I");

   for (int i = 0; i < 10; i++) {
      var1 = i;
      tree.Fill();
   }

   f.Write();
}

int main(){
    generateData();

    TChain c{"Events"};
    for (int i = 0; i < 3; i++){
        c.Add("testfile.root");
    }
    auto entries = c.GetEntries();

    MyNotifier n;
    TNotifyLink<MyNotifier> l{&n};
    l.PrependLink(c);

    for (decltype(entries) i = 0; i < entries; i++)
    {
        c.GetEntry(i);
        std::cout << "entry " << i << "\n";
    }
}
